var http = require('http');
var fs = require('fs');

var delay = require('delay-stream');

var img = fs.readFileSync('./big-image.png');

console.log(img.length);

function serve_img(req, res) {
    res.setHeader('content-type', 'image/png');

    var n = 5000;
    var offset = 0;
    (function next() {
        if (offset >= img.length) {
            // done
            res.end();
        }

        if (offset + n > img.length) {
            n = img.length - offset;
        }

        var r = res.write(img.slice(offset, offset + n), function() {
            offset += n;
            next();
        });

        if (r) {
            offset += n;
            setTimeout(next, 100);
        }
    })();
}

http.createServer(function(req, res) {

    if (req.url.indexOf('png') > 0) {
        return serve_img(req, res);
    }

    res.setHeader('content-type', 'text/html');
    fs.createReadStream('./index.html').pipe(res);

}).listen(3000);
